package hay.app;

import hay.component.HayAnniversary;
import hay.component.HayAnniversaryAdapter;
import hay.component.HayContact;
import hay.component.HayContactAdapter;
import hay.database.HayDatabase;
import java.util.ArrayList;
import android.app.AlertDialog;
import android.app.ListActivity;
import android.content.Context;
import android.content.DialogInterface;
import android.content.Intent;
import android.database.Cursor;
import android.net.Uri;
import android.os.Bundle;
import android.provider.ContactsContract;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.ArrayAdapter;
import android.widget.ListView;
import android.widget.TextView;

public class HayAnniversaryActivity extends ListActivity {

	private ArrayList<Anniversary> cateList;

	private ListAdapter cAdapter;

	private TextView textview; 

	public void onCreate(Bundle savedInstanceState) {
		super.onCreate(savedInstanceState);
		setContentView(R.layout.anniversary);
		cateList = new ArrayList<Anniversary>();
		cAdapter = new ListAdapter(cateList);
		textview = (TextView)findViewById(R.anniversary.text);
		setListAdapter(cAdapter);
		
		getWindow().setTitle("Ϻ");
	}
	
	protected void onResume() {
		super.onResume();
		cateList.clear();
		addAnniversary();
		if(cateList.size()==0){
			textview.setText("ֱٿ ,  ϴ.");
		}
		else{
			textview.setText("ֱ , Դϴ.");
		}
		cAdapter.notifyDataSetChanged();
	}

	private void addAnniversary(){
		HayDatabase db = new HayDatabase(this);
		db.open();

		// ¥ ó ϵ ´.
		HayAnniversaryAdapter ba = new HayAnniversaryAdapter(getContentResolver());
		ArrayList<HayAnniversary> birthdays = ba.getBirthdays(8,4);
		
		for( int i=0 ; i<birthdays.size() ; i++ ){
			
			//ϳ ͼ
			HayAnniversary birthday = birthdays.get(i);
			
			//contact_id ͺ
			int rawcontact_id = birthday.getRawcontact_id();
			int contact_id = -1;
			
			Cursor cursor2 = getContentResolver().query(ContactsContract.RawContacts.CONTENT_URI,
					null,
					ContactsContract.RawContacts._ID+"="+rawcontact_id,
					null, null);
			if(cursor2.moveToNext()){
				contact_id = cursor2.getInt(cursor2.getColumnIndex(ContactsContract.RawContacts.CONTACT_ID));
			}
			
			//̸ϰ ȭȣ ͺ
			HayContactAdapter contactadapter = new HayContactAdapter(getContentResolver());
			HayContact contact = contactadapter.getContact(contact_id);
			
			Anniversary anniversary = new Anniversary();
			
			//   ϰ
			anniversary.setYear(birthday.getYear());
			anniversary.setMonth(birthday.getMonth());
			anniversary.setDay(birthday.getDay());
			anniversary.setRemain(birthday.getRemain());
			anniversary.setLunar(birthday.isLunar());
			anniversary.setBirthday( (birthday.getType()==3)?true:false);
			anniversary.setContact_id(contact_id);
			anniversary.setDisplayname(contact.getDisplay_name());
			anniversary.setName(birthday.getText());
			anniversary.setPhonenumber(contact.getPhone_number());
			
			//Ʈ 
			cateList.add(anniversary);
		}
		db.close();
	}

	

	private class ListAdapter extends ArrayAdapter<Anniversary> {
		private ArrayList<Anniversary> items;
		public ListAdapter(ArrayList<Anniversary> items) {
			super(HayAnniversaryActivity.this, 0, items);
			this.items = items;
		}
		public View getView(int position, View convertView, ViewGroup parent) {
			View v = convertView;
			if (v == null) {
				LayoutInflater vi = (LayoutInflater) getSystemService(Context.LAYOUT_INFLATER_SERVICE);
				v = vi.inflate(R.layout.list_anniversary, null);
			}

			TextView name_t = (TextView) v.findViewById(R.list_anniversary.Text_Name);
			TextView date_t = (TextView) v.findViewById(R.list_anniversary.Text_Date);
			TextView divid_t = (TextView) v.findViewById(R.list_anniversary.Text_divid);
			TextView remain_t = (TextView) v.findViewById(R.list_anniversary.Text_Remain);

			String what = (items.get(position).isBirthday())?(" "):(" ");
			//what += items.get(position).getName()+' ';
			String lunar = (items.get(position).isLunar())?(""):(""); 
			divid_t.setText("'"+items.get(position).getDisplayname()+"'"+"\n"+what);
			name_t.setText(items.get(position).getName());
			date_t.setText(lunar+" "+items.get(position).getYear()+" "+items.get(position).getMonth()+" "+items.get(position).getDay()+"");

			int remain = items.get(position).getRemain();

			if(remain == 0) remain_t.setText(" "+what+"Դϴ.");
			else if(remain > 0) remain_t.setText(what+remain+" ϴ.");
			else remain_t.setText(what+(-remain)+" ҽϴ.");

			return v;
		}
	}

	String[] selectNumber;
	protected void onListItemClick(ListView l, View v, final int position,long id) {
		super.onListItemClick(l, v, position, id);

		String[] selectString = new String[] { "Call", "SMS", " " };

		selectNumber = new String[cateList.get(position).getPhonenumber().size()];

		for(int i=0 ; i<selectNumber.length ; i++){
			selectNumber[i] = cateList.get(position).getPhonenumber().get(i);
		}

		new AlertDialog.Builder(this).setTitle("ϼ").setIcon(R.drawable.icon).setItems(selectString,
				new DialogInterface.OnClickListener() {
			public void onClick(DialogInterface dialog, int what) {
				switch (what) {
				case 0:// ȭκ

					if(selectNumber.length>1){
						//ȭȣ 
						new AlertDialog.Builder(HayAnniversaryActivity.this).setTitle("ϼ").setIcon(R.drawable.icon).setItems(selectNumber,
								new DialogInterface.OnClickListener() {
							public void onClick(DialogInterface dialog, int which) {
								Intent i = new Intent(Intent.ACTION_CALL, Uri.parse("tel:"+ selectNumber[which]));
								startActivity(i);
							}
						}).setNegativeButton("", null).show();
					}else{
						//ٷ ȭ
						Intent i = new Intent(Intent.ACTION_CALL, Uri.parse("tel:"+ selectNumber[0]));
						startActivity(i);
					}
					break;

				case 1: // ںκ
					if(selectNumber.length>1){
						//ȭȣ
						new AlertDialog.Builder(HayAnniversaryActivity.this).setTitle("ϼ").setIcon(R.drawable.icon).setItems(selectNumber,
								new DialogInterface.OnClickListener() {
							public void onClick(DialogInterface dialog, int which) {
								Intent i2 = new Intent(HayAnniversaryActivity.this,HaySmsDetail.class);
								i2.putExtra("contact_number",selectNumber[which]);
								startActivity(i2);
							}
						}).setNegativeButton("", null).show();
					}else{
						//ٷ ȭ
						Intent i2 = new Intent(HayAnniversaryActivity.this,HaySmsDetail.class);
						i2.putExtra("contact_number",selectNumber[0]);
						startActivity(i2);
					}
					break;

				case 2: // 
					Intent intent = new Intent(HayAnniversaryActivity.this, HayDetail.class);
					intent.putExtra("contact_id", cateList.get(position).getContact_id());
					startActivity(intent);
					break;
				}
			}
		}).setNegativeButton("", null).show();
	}


	private class Anniversary{
		boolean birthday;
		int year;
		int month;
		int day;
		int contact_id;
		String name;
		int remain;
		String displayname;
		ArrayList<String> phonenumber;
		boolean lunar;



		public boolean isLunar() {
			return lunar;
		}
		public void setLunar(boolean lunar) {
			this.lunar = lunar;
		}
		public String getDisplayname() {
			return displayname;
		}
		public void setDisplayname(String displayname) {
			this.displayname = displayname;
		}
		public ArrayList<String> getPhonenumber() {
			return phonenumber;
		}
		public void setPhonenumber(ArrayList<String> phonenumber) {
			this.phonenumber = phonenumber;
		}
		public int getRemain() {
			return remain;
		}
		public void setRemain(int remain) {
			this.remain = remain;
		}
		public boolean isBirthday() {
			return birthday;
		}
		public void setBirthday(boolean birthday) {
			this.birthday = birthday;
		}
		public int getYear() {
			return year;
		}
		public void setYear(int year) {
			this.year = year;
		}
		public int getMonth() {
			return month;
		}
		public void setMonth(int month) {
			this.month = month;
		}
		public int getDay() {
			return day;
		}
		public void setDay(int day) {
			this.day = day;
		}
		public String getName() {
			return name;
		}
		public void setName(String name) {
			this.name = name;
		}
		public int getContact_id() {
			return contact_id;
		}
		public void setContact_id(int contactId) {
			contact_id = contactId;
		}
	}
}
